
# Cisco IOS XE Resource Provider

The Cisco IOXE resource provider for Pulumi lets you creating resources in the [Cisco IOS XE](https://www.cisco.com/c/en/us/products/ios-nx-os-software/ios-xe/index.html) API. To use
this package, please [install the Pulumi CLI first](https://pulumi.com/).

## Installing

This package is available in many languages in the standard packaging formats.

### Node.js (Java/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```
$ npm install @lbrlabs/pulumi-iosxe
```

or `yarn`:

```
$ yarn add @lbrlabs/pulumi-iosxe
```

### Python

To use from Python, install using `pip`:

```
$ pip install lbrlabs_pulumi_iosxe
```

### Go

To use from Go, use `go get` to grab the latest version of the library

```
$ go get github.com/lbrlabs/pulumi-iosxe/sdk/go/...
```

### .NET

To use from Dotnet, use `dotnet add package` to install into your project. You must specify the version if it is a pre-release version.


```
$ dotnet add package Lbrlabs.PulumiPackage.Iosxe
```

## Reference

See the Pulumi registry for API docs:

https://www.pulumi.com/registry/packages/iosxe/api-docs/
