# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AaaAuthenticationArgs', 'AaaAuthentication']

@pulumi.input_type
class AaaAuthenticationArgs:
    def __init__(__self__, *,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a2_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a2_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a3_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a3_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a4_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a4_local: Optional[pulumi.Input[bool]] = None,
                 logins: Optional[pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]]] = None):
        """
        The set of arguments for constructing a AaaAuthentication resource.
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] dot1x_default_a1_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a1_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a2_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a2_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a3_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a3_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a4_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a4_local: Use local username authentication
        :param pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]] logins: Set authentication lists for logins.
        """
        if delete_mode is not None:
            pulumi.set(__self__, "delete_mode", delete_mode)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if dot1x_default_a1_group is not None:
            pulumi.set(__self__, "dot1x_default_a1_group", dot1x_default_a1_group)
        if dot1x_default_a1_local is not None:
            pulumi.set(__self__, "dot1x_default_a1_local", dot1x_default_a1_local)
        if dot1x_default_a2_group is not None:
            pulumi.set(__self__, "dot1x_default_a2_group", dot1x_default_a2_group)
        if dot1x_default_a2_local is not None:
            pulumi.set(__self__, "dot1x_default_a2_local", dot1x_default_a2_local)
        if dot1x_default_a3_group is not None:
            pulumi.set(__self__, "dot1x_default_a3_group", dot1x_default_a3_group)
        if dot1x_default_a3_local is not None:
            pulumi.set(__self__, "dot1x_default_a3_local", dot1x_default_a3_local)
        if dot1x_default_a4_group is not None:
            pulumi.set(__self__, "dot1x_default_a4_group", dot1x_default_a4_group)
        if dot1x_default_a4_local is not None:
            pulumi.set(__self__, "dot1x_default_a4_local", dot1x_default_a4_local)
        if logins is not None:
            pulumi.set(__self__, "logins", logins)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @delete_mode.setter
    def delete_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_mode", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="dot1xDefaultA1Group")
    def dot1x_default_a1_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a1_group")

    @dot1x_default_a1_group.setter
    def dot1x_default_a1_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a1_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA1Local")
    def dot1x_default_a1_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a1_local")

    @dot1x_default_a1_local.setter
    def dot1x_default_a1_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a1_local", value)

    @property
    @pulumi.getter(name="dot1xDefaultA2Group")
    def dot1x_default_a2_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a2_group")

    @dot1x_default_a2_group.setter
    def dot1x_default_a2_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a2_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA2Local")
    def dot1x_default_a2_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a2_local")

    @dot1x_default_a2_local.setter
    def dot1x_default_a2_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a2_local", value)

    @property
    @pulumi.getter(name="dot1xDefaultA3Group")
    def dot1x_default_a3_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a3_group")

    @dot1x_default_a3_group.setter
    def dot1x_default_a3_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a3_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA3Local")
    def dot1x_default_a3_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a3_local")

    @dot1x_default_a3_local.setter
    def dot1x_default_a3_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a3_local", value)

    @property
    @pulumi.getter(name="dot1xDefaultA4Group")
    def dot1x_default_a4_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a4_group")

    @dot1x_default_a4_group.setter
    def dot1x_default_a4_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a4_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA4Local")
    def dot1x_default_a4_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a4_local")

    @dot1x_default_a4_local.setter
    def dot1x_default_a4_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a4_local", value)

    @property
    @pulumi.getter
    def logins(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]]]:
        """
        Set authentication lists for logins.
        """
        return pulumi.get(self, "logins")

    @logins.setter
    def logins(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]]]):
        pulumi.set(self, "logins", value)


@pulumi.input_type
class _AaaAuthenticationState:
    def __init__(__self__, *,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a2_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a2_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a3_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a3_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a4_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a4_local: Optional[pulumi.Input[bool]] = None,
                 logins: Optional[pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]]] = None):
        """
        Input properties used for looking up and filtering AaaAuthentication resources.
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] dot1x_default_a1_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a1_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a2_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a2_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a3_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a3_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a4_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a4_local: Use local username authentication
        :param pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]] logins: Set authentication lists for logins.
        """
        if delete_mode is not None:
            pulumi.set(__self__, "delete_mode", delete_mode)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if dot1x_default_a1_group is not None:
            pulumi.set(__self__, "dot1x_default_a1_group", dot1x_default_a1_group)
        if dot1x_default_a1_local is not None:
            pulumi.set(__self__, "dot1x_default_a1_local", dot1x_default_a1_local)
        if dot1x_default_a2_group is not None:
            pulumi.set(__self__, "dot1x_default_a2_group", dot1x_default_a2_group)
        if dot1x_default_a2_local is not None:
            pulumi.set(__self__, "dot1x_default_a2_local", dot1x_default_a2_local)
        if dot1x_default_a3_group is not None:
            pulumi.set(__self__, "dot1x_default_a3_group", dot1x_default_a3_group)
        if dot1x_default_a3_local is not None:
            pulumi.set(__self__, "dot1x_default_a3_local", dot1x_default_a3_local)
        if dot1x_default_a4_group is not None:
            pulumi.set(__self__, "dot1x_default_a4_group", dot1x_default_a4_group)
        if dot1x_default_a4_local is not None:
            pulumi.set(__self__, "dot1x_default_a4_local", dot1x_default_a4_local)
        if logins is not None:
            pulumi.set(__self__, "logins", logins)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @delete_mode.setter
    def delete_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_mode", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="dot1xDefaultA1Group")
    def dot1x_default_a1_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a1_group")

    @dot1x_default_a1_group.setter
    def dot1x_default_a1_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a1_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA1Local")
    def dot1x_default_a1_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a1_local")

    @dot1x_default_a1_local.setter
    def dot1x_default_a1_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a1_local", value)

    @property
    @pulumi.getter(name="dot1xDefaultA2Group")
    def dot1x_default_a2_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a2_group")

    @dot1x_default_a2_group.setter
    def dot1x_default_a2_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a2_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA2Local")
    def dot1x_default_a2_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a2_local")

    @dot1x_default_a2_local.setter
    def dot1x_default_a2_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a2_local", value)

    @property
    @pulumi.getter(name="dot1xDefaultA3Group")
    def dot1x_default_a3_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a3_group")

    @dot1x_default_a3_group.setter
    def dot1x_default_a3_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a3_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA3Local")
    def dot1x_default_a3_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a3_local")

    @dot1x_default_a3_local.setter
    def dot1x_default_a3_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a3_local", value)

    @property
    @pulumi.getter(name="dot1xDefaultA4Group")
    def dot1x_default_a4_group(self) -> Optional[pulumi.Input[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a4_group")

    @dot1x_default_a4_group.setter
    def dot1x_default_a4_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dot1x_default_a4_group", value)

    @property
    @pulumi.getter(name="dot1xDefaultA4Local")
    def dot1x_default_a4_local(self) -> Optional[pulumi.Input[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a4_local")

    @dot1x_default_a4_local.setter
    def dot1x_default_a4_local(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dot1x_default_a4_local", value)

    @property
    @pulumi.getter
    def logins(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]]]:
        """
        Set authentication lists for logins.
        """
        return pulumi.get(self, "logins")

    @logins.setter
    def logins(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AaaAuthenticationLoginArgs']]]]):
        pulumi.set(self, "logins", value)


class AaaAuthentication(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a2_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a2_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a3_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a3_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a4_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a4_local: Optional[pulumi.Input[bool]] = None,
                 logins: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AaaAuthenticationLoginArgs']]]]] = None,
                 __props__=None):
        """
        This resource can manage the AAA Authentication configuration.

        ## Import

        ```sh
         $ pulumi import iosxe:index/aaaAuthentication:AaaAuthentication example "Cisco-IOS-XE-native:native/aaa/Cisco-IOS-XE-aaa:authentication"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] dot1x_default_a1_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a1_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a2_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a2_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a3_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a3_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a4_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a4_local: Use local username authentication
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AaaAuthenticationLoginArgs']]]] logins: Set authentication lists for logins.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[AaaAuthenticationArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the AAA Authentication configuration.

        ## Import

        ```sh
         $ pulumi import iosxe:index/aaaAuthentication:AaaAuthentication example "Cisco-IOS-XE-native:native/aaa/Cisco-IOS-XE-aaa:authentication"
        ```

        :param str resource_name: The name of the resource.
        :param AaaAuthenticationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AaaAuthenticationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a1_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a2_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a2_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a3_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a3_local: Optional[pulumi.Input[bool]] = None,
                 dot1x_default_a4_group: Optional[pulumi.Input[str]] = None,
                 dot1x_default_a4_local: Optional[pulumi.Input[bool]] = None,
                 logins: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AaaAuthenticationLoginArgs']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AaaAuthenticationArgs.__new__(AaaAuthenticationArgs)

            __props__.__dict__["delete_mode"] = delete_mode
            __props__.__dict__["device"] = device
            __props__.__dict__["dot1x_default_a1_group"] = dot1x_default_a1_group
            __props__.__dict__["dot1x_default_a1_local"] = dot1x_default_a1_local
            __props__.__dict__["dot1x_default_a2_group"] = dot1x_default_a2_group
            __props__.__dict__["dot1x_default_a2_local"] = dot1x_default_a2_local
            __props__.__dict__["dot1x_default_a3_group"] = dot1x_default_a3_group
            __props__.__dict__["dot1x_default_a3_local"] = dot1x_default_a3_local
            __props__.__dict__["dot1x_default_a4_group"] = dot1x_default_a4_group
            __props__.__dict__["dot1x_default_a4_local"] = dot1x_default_a4_local
            __props__.__dict__["logins"] = logins
        super(AaaAuthentication, __self__).__init__(
            'iosxe:index/aaaAuthentication:AaaAuthentication',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            delete_mode: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            dot1x_default_a1_group: Optional[pulumi.Input[str]] = None,
            dot1x_default_a1_local: Optional[pulumi.Input[bool]] = None,
            dot1x_default_a2_group: Optional[pulumi.Input[str]] = None,
            dot1x_default_a2_local: Optional[pulumi.Input[bool]] = None,
            dot1x_default_a3_group: Optional[pulumi.Input[str]] = None,
            dot1x_default_a3_local: Optional[pulumi.Input[bool]] = None,
            dot1x_default_a4_group: Optional[pulumi.Input[str]] = None,
            dot1x_default_a4_local: Optional[pulumi.Input[bool]] = None,
            logins: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AaaAuthenticationLoginArgs']]]]] = None) -> 'AaaAuthentication':
        """
        Get an existing AaaAuthentication resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] dot1x_default_a1_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a1_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a2_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a2_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a3_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a3_local: Use local username authentication
        :param pulumi.Input[str] dot1x_default_a4_group: Use Server-group
        :param pulumi.Input[bool] dot1x_default_a4_local: Use local username authentication
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AaaAuthenticationLoginArgs']]]] logins: Set authentication lists for logins.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AaaAuthenticationState.__new__(_AaaAuthenticationState)

        __props__.__dict__["delete_mode"] = delete_mode
        __props__.__dict__["device"] = device
        __props__.__dict__["dot1x_default_a1_group"] = dot1x_default_a1_group
        __props__.__dict__["dot1x_default_a1_local"] = dot1x_default_a1_local
        __props__.__dict__["dot1x_default_a2_group"] = dot1x_default_a2_group
        __props__.__dict__["dot1x_default_a2_local"] = dot1x_default_a2_local
        __props__.__dict__["dot1x_default_a3_group"] = dot1x_default_a3_group
        __props__.__dict__["dot1x_default_a3_local"] = dot1x_default_a3_local
        __props__.__dict__["dot1x_default_a4_group"] = dot1x_default_a4_group
        __props__.__dict__["dot1x_default_a4_local"] = dot1x_default_a4_local
        __props__.__dict__["logins"] = logins
        return AaaAuthentication(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> pulumi.Output[Optional[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="dot1xDefaultA1Group")
    def dot1x_default_a1_group(self) -> pulumi.Output[Optional[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a1_group")

    @property
    @pulumi.getter(name="dot1xDefaultA1Local")
    def dot1x_default_a1_local(self) -> pulumi.Output[Optional[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a1_local")

    @property
    @pulumi.getter(name="dot1xDefaultA2Group")
    def dot1x_default_a2_group(self) -> pulumi.Output[Optional[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a2_group")

    @property
    @pulumi.getter(name="dot1xDefaultA2Local")
    def dot1x_default_a2_local(self) -> pulumi.Output[Optional[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a2_local")

    @property
    @pulumi.getter(name="dot1xDefaultA3Group")
    def dot1x_default_a3_group(self) -> pulumi.Output[Optional[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a3_group")

    @property
    @pulumi.getter(name="dot1xDefaultA3Local")
    def dot1x_default_a3_local(self) -> pulumi.Output[Optional[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a3_local")

    @property
    @pulumi.getter(name="dot1xDefaultA4Group")
    def dot1x_default_a4_group(self) -> pulumi.Output[Optional[str]]:
        """
        Use Server-group
        """
        return pulumi.get(self, "dot1x_default_a4_group")

    @property
    @pulumi.getter(name="dot1xDefaultA4Local")
    def dot1x_default_a4_local(self) -> pulumi.Output[Optional[bool]]:
        """
        Use local username authentication
        """
        return pulumi.get(self, "dot1x_default_a4_local")

    @property
    @pulumi.getter
    def logins(self) -> pulumi.Output[Optional[Sequence['outputs.AaaAuthenticationLogin']]]:
        """
        Set authentication lists for logins.
        """
        return pulumi.get(self, "logins")

