# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetCryptoIkev2KeyringResult',
    'AwaitableGetCryptoIkev2KeyringResult',
    'get_crypto_ikev2_keyring',
    'get_crypto_ikev2_keyring_output',
]

@pulumi.output_type
class GetCryptoIkev2KeyringResult:
    """
    A collection of values returned by getCryptoIkev2Keyring.
    """
    def __init__(__self__, device=None, id=None, name=None, peers=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if peers and not isinstance(peers, list):
            raise TypeError("Expected argument 'peers' to be a list")
        pulumi.set(__self__, "peers", peers)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The path of the retrieved object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def peers(self) -> Sequence['outputs.GetCryptoIkev2KeyringPeerResult']:
        """
        Configure a Peer and associated keys
        """
        return pulumi.get(self, "peers")


class AwaitableGetCryptoIkev2KeyringResult(GetCryptoIkev2KeyringResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCryptoIkev2KeyringResult(
            device=self.device,
            id=self.id,
            name=self.name,
            peers=self.peers)


def get_crypto_ikev2_keyring(device: Optional[str] = None,
                             name: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCryptoIkev2KeyringResult:
    """
    This data source can read the Crypto IKEv2 Keyring configuration.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_iosxe as iosxe

    example = iosxe.get_crypto_ikev2_keyring(name="keyring1")
    ```


    :param str device: A device name from the provider configuration.
    """
    __args__ = dict()
    __args__['device'] = device
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('iosxe:index/getCryptoIkev2Keyring:getCryptoIkev2Keyring', __args__, opts=opts, typ=GetCryptoIkev2KeyringResult).value

    return AwaitableGetCryptoIkev2KeyringResult(
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        peers=pulumi.get(__ret__, 'peers'))


@_utilities.lift_output_func(get_crypto_ikev2_keyring)
def get_crypto_ikev2_keyring_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                                    name: Optional[pulumi.Input[str]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCryptoIkev2KeyringResult]:
    """
    This data source can read the Crypto IKEv2 Keyring configuration.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_iosxe as iosxe

    example = iosxe.get_crypto_ikev2_keyring(name="keyring1")
    ```


    :param str device: A device name from the provider configuration.
    """
    ...
