# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InterfaceLoopbackArgs', 'InterfaceLoopback']

@pulumi.input_type
class InterfaceLoopbackArgs:
    def __init__(__self__, *,
                 arp_timeout: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in_enable: Optional[pulumi.Input[bool]] = None,
                 ip_access_group_out: Optional[pulumi.Input[str]] = None,
                 ip_access_group_out_enable: Optional[pulumi.Input[bool]] = None,
                 ip_proxy_arp: Optional[pulumi.Input[bool]] = None,
                 ip_redirects: Optional[pulumi.Input[bool]] = None,
                 ip_unreachables: Optional[pulumi.Input[bool]] = None,
                 ipv4_address: Optional[pulumi.Input[str]] = None,
                 ipv4_address_mask: Optional[pulumi.Input[str]] = None,
                 ipv6_address_autoconfig_default: Optional[pulumi.Input[bool]] = None,
                 ipv6_address_dhcp: Optional[pulumi.Input[bool]] = None,
                 ipv6_addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6AddressArgs']]]] = None,
                 ipv6_enable: Optional[pulumi.Input[bool]] = None,
                 ipv6_link_local_addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]] = None,
                 ipv6_mtu: Optional[pulumi.Input[int]] = None,
                 ipv6_nd_ra_suppress_all: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[int]] = None,
                 shutdown: Optional[pulumi.Input[bool]] = None,
                 vrf_forwarding: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a InterfaceLoopback resource.
        :param pulumi.Input[int] arp_timeout: Set ARP cache timeout - Range: `0`-`2147483`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] description: Interface specific description
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[bool] ip_access_group_in_enable: inbound packets
        :param pulumi.Input[bool] ip_access_group_out_enable: outbound packets
        :param pulumi.Input[bool] ip_proxy_arp: Enable proxy ARP
        :param pulumi.Input[bool] ip_redirects: Enable sending ICMP Redirect messages
        :param pulumi.Input[bool] ip_unreachables: Enable sending ICMP Unreachable messages
        :param pulumi.Input[bool] ipv6_address_autoconfig_default: Insert default route
        :param pulumi.Input[bool] ipv6_address_dhcp: Obtain IPv6 address from DHCP server
        :param pulumi.Input[bool] ipv6_enable: Enable IPv6 on interface
        :param pulumi.Input[int] ipv6_mtu: Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        :param pulumi.Input[bool] ipv6_nd_ra_suppress_all: Suppress all IPv6 RA
        :param pulumi.Input[int] name: - Range: `0`-`2147483647`
        :param pulumi.Input[bool] shutdown: Shutdown the selected interface
        :param pulumi.Input[str] vrf_forwarding: Configure forwarding table
        """
        if arp_timeout is not None:
            pulumi.set(__self__, "arp_timeout", arp_timeout)
        if delete_mode is not None:
            pulumi.set(__self__, "delete_mode", delete_mode)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if ip_access_group_in is not None:
            pulumi.set(__self__, "ip_access_group_in", ip_access_group_in)
        if ip_access_group_in_enable is not None:
            pulumi.set(__self__, "ip_access_group_in_enable", ip_access_group_in_enable)
        if ip_access_group_out is not None:
            pulumi.set(__self__, "ip_access_group_out", ip_access_group_out)
        if ip_access_group_out_enable is not None:
            pulumi.set(__self__, "ip_access_group_out_enable", ip_access_group_out_enable)
        if ip_proxy_arp is not None:
            pulumi.set(__self__, "ip_proxy_arp", ip_proxy_arp)
        if ip_redirects is not None:
            pulumi.set(__self__, "ip_redirects", ip_redirects)
        if ip_unreachables is not None:
            pulumi.set(__self__, "ip_unreachables", ip_unreachables)
        if ipv4_address is not None:
            pulumi.set(__self__, "ipv4_address", ipv4_address)
        if ipv4_address_mask is not None:
            pulumi.set(__self__, "ipv4_address_mask", ipv4_address_mask)
        if ipv6_address_autoconfig_default is not None:
            pulumi.set(__self__, "ipv6_address_autoconfig_default", ipv6_address_autoconfig_default)
        if ipv6_address_dhcp is not None:
            pulumi.set(__self__, "ipv6_address_dhcp", ipv6_address_dhcp)
        if ipv6_addresses is not None:
            pulumi.set(__self__, "ipv6_addresses", ipv6_addresses)
        if ipv6_enable is not None:
            pulumi.set(__self__, "ipv6_enable", ipv6_enable)
        if ipv6_link_local_addresses is not None:
            pulumi.set(__self__, "ipv6_link_local_addresses", ipv6_link_local_addresses)
        if ipv6_mtu is not None:
            pulumi.set(__self__, "ipv6_mtu", ipv6_mtu)
        if ipv6_nd_ra_suppress_all is not None:
            pulumi.set(__self__, "ipv6_nd_ra_suppress_all", ipv6_nd_ra_suppress_all)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if shutdown is not None:
            pulumi.set(__self__, "shutdown", shutdown)
        if vrf_forwarding is not None:
            pulumi.set(__self__, "vrf_forwarding", vrf_forwarding)

    @property
    @pulumi.getter(name="arpTimeout")
    def arp_timeout(self) -> Optional[pulumi.Input[int]]:
        """
        Set ARP cache timeout - Range: `0`-`2147483`
        """
        return pulumi.get(self, "arp_timeout")

    @arp_timeout.setter
    def arp_timeout(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "arp_timeout", value)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @delete_mode.setter
    def delete_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_mode", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Interface specific description
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="ipAccessGroupIn")
    def ip_access_group_in(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ip_access_group_in")

    @ip_access_group_in.setter
    def ip_access_group_in(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_access_group_in", value)

    @property
    @pulumi.getter(name="ipAccessGroupInEnable")
    def ip_access_group_in_enable(self) -> Optional[pulumi.Input[bool]]:
        """
        inbound packets
        """
        return pulumi.get(self, "ip_access_group_in_enable")

    @ip_access_group_in_enable.setter
    def ip_access_group_in_enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_access_group_in_enable", value)

    @property
    @pulumi.getter(name="ipAccessGroupOut")
    def ip_access_group_out(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ip_access_group_out")

    @ip_access_group_out.setter
    def ip_access_group_out(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_access_group_out", value)

    @property
    @pulumi.getter(name="ipAccessGroupOutEnable")
    def ip_access_group_out_enable(self) -> Optional[pulumi.Input[bool]]:
        """
        outbound packets
        """
        return pulumi.get(self, "ip_access_group_out_enable")

    @ip_access_group_out_enable.setter
    def ip_access_group_out_enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_access_group_out_enable", value)

    @property
    @pulumi.getter(name="ipProxyArp")
    def ip_proxy_arp(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable proxy ARP
        """
        return pulumi.get(self, "ip_proxy_arp")

    @ip_proxy_arp.setter
    def ip_proxy_arp(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_proxy_arp", value)

    @property
    @pulumi.getter(name="ipRedirects")
    def ip_redirects(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable sending ICMP Redirect messages
        """
        return pulumi.get(self, "ip_redirects")

    @ip_redirects.setter
    def ip_redirects(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_redirects", value)

    @property
    @pulumi.getter(name="ipUnreachables")
    def ip_unreachables(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable sending ICMP Unreachable messages
        """
        return pulumi.get(self, "ip_unreachables")

    @ip_unreachables.setter
    def ip_unreachables(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_unreachables", value)

    @property
    @pulumi.getter(name="ipv4Address")
    def ipv4_address(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ipv4_address")

    @ipv4_address.setter
    def ipv4_address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipv4_address", value)

    @property
    @pulumi.getter(name="ipv4AddressMask")
    def ipv4_address_mask(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ipv4_address_mask")

    @ipv4_address_mask.setter
    def ipv4_address_mask(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipv4_address_mask", value)

    @property
    @pulumi.getter(name="ipv6AddressAutoconfigDefault")
    def ipv6_address_autoconfig_default(self) -> Optional[pulumi.Input[bool]]:
        """
        Insert default route
        """
        return pulumi.get(self, "ipv6_address_autoconfig_default")

    @ipv6_address_autoconfig_default.setter
    def ipv6_address_autoconfig_default(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_address_autoconfig_default", value)

    @property
    @pulumi.getter(name="ipv6AddressDhcp")
    def ipv6_address_dhcp(self) -> Optional[pulumi.Input[bool]]:
        """
        Obtain IPv6 address from DHCP server
        """
        return pulumi.get(self, "ipv6_address_dhcp")

    @ipv6_address_dhcp.setter
    def ipv6_address_dhcp(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_address_dhcp", value)

    @property
    @pulumi.getter(name="ipv6Addresses")
    def ipv6_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6AddressArgs']]]]:
        return pulumi.get(self, "ipv6_addresses")

    @ipv6_addresses.setter
    def ipv6_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6AddressArgs']]]]):
        pulumi.set(self, "ipv6_addresses", value)

    @property
    @pulumi.getter(name="ipv6Enable")
    def ipv6_enable(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable IPv6 on interface
        """
        return pulumi.get(self, "ipv6_enable")

    @ipv6_enable.setter
    def ipv6_enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_enable", value)

    @property
    @pulumi.getter(name="ipv6LinkLocalAddresses")
    def ipv6_link_local_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]:
        return pulumi.get(self, "ipv6_link_local_addresses")

    @ipv6_link_local_addresses.setter
    def ipv6_link_local_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]):
        pulumi.set(self, "ipv6_link_local_addresses", value)

    @property
    @pulumi.getter(name="ipv6Mtu")
    def ipv6_mtu(self) -> Optional[pulumi.Input[int]]:
        """
        Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        """
        return pulumi.get(self, "ipv6_mtu")

    @ipv6_mtu.setter
    def ipv6_mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ipv6_mtu", value)

    @property
    @pulumi.getter(name="ipv6NdRaSuppressAll")
    def ipv6_nd_ra_suppress_all(self) -> Optional[pulumi.Input[bool]]:
        """
        Suppress all IPv6 RA
        """
        return pulumi.get(self, "ipv6_nd_ra_suppress_all")

    @ipv6_nd_ra_suppress_all.setter
    def ipv6_nd_ra_suppress_all(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_nd_ra_suppress_all", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[int]]:
        """
        - Range: `0`-`2147483647`
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def shutdown(self) -> Optional[pulumi.Input[bool]]:
        """
        Shutdown the selected interface
        """
        return pulumi.get(self, "shutdown")

    @shutdown.setter
    def shutdown(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "shutdown", value)

    @property
    @pulumi.getter(name="vrfForwarding")
    def vrf_forwarding(self) -> Optional[pulumi.Input[str]]:
        """
        Configure forwarding table
        """
        return pulumi.get(self, "vrf_forwarding")

    @vrf_forwarding.setter
    def vrf_forwarding(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vrf_forwarding", value)


@pulumi.input_type
class _InterfaceLoopbackState:
    def __init__(__self__, *,
                 arp_timeout: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in_enable: Optional[pulumi.Input[bool]] = None,
                 ip_access_group_out: Optional[pulumi.Input[str]] = None,
                 ip_access_group_out_enable: Optional[pulumi.Input[bool]] = None,
                 ip_proxy_arp: Optional[pulumi.Input[bool]] = None,
                 ip_redirects: Optional[pulumi.Input[bool]] = None,
                 ip_unreachables: Optional[pulumi.Input[bool]] = None,
                 ipv4_address: Optional[pulumi.Input[str]] = None,
                 ipv4_address_mask: Optional[pulumi.Input[str]] = None,
                 ipv6_address_autoconfig_default: Optional[pulumi.Input[bool]] = None,
                 ipv6_address_dhcp: Optional[pulumi.Input[bool]] = None,
                 ipv6_addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6AddressArgs']]]] = None,
                 ipv6_enable: Optional[pulumi.Input[bool]] = None,
                 ipv6_link_local_addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]] = None,
                 ipv6_mtu: Optional[pulumi.Input[int]] = None,
                 ipv6_nd_ra_suppress_all: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[int]] = None,
                 shutdown: Optional[pulumi.Input[bool]] = None,
                 vrf_forwarding: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering InterfaceLoopback resources.
        :param pulumi.Input[int] arp_timeout: Set ARP cache timeout - Range: `0`-`2147483`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] description: Interface specific description
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[bool] ip_access_group_in_enable: inbound packets
        :param pulumi.Input[bool] ip_access_group_out_enable: outbound packets
        :param pulumi.Input[bool] ip_proxy_arp: Enable proxy ARP
        :param pulumi.Input[bool] ip_redirects: Enable sending ICMP Redirect messages
        :param pulumi.Input[bool] ip_unreachables: Enable sending ICMP Unreachable messages
        :param pulumi.Input[bool] ipv6_address_autoconfig_default: Insert default route
        :param pulumi.Input[bool] ipv6_address_dhcp: Obtain IPv6 address from DHCP server
        :param pulumi.Input[bool] ipv6_enable: Enable IPv6 on interface
        :param pulumi.Input[int] ipv6_mtu: Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        :param pulumi.Input[bool] ipv6_nd_ra_suppress_all: Suppress all IPv6 RA
        :param pulumi.Input[int] name: - Range: `0`-`2147483647`
        :param pulumi.Input[bool] shutdown: Shutdown the selected interface
        :param pulumi.Input[str] vrf_forwarding: Configure forwarding table
        """
        if arp_timeout is not None:
            pulumi.set(__self__, "arp_timeout", arp_timeout)
        if delete_mode is not None:
            pulumi.set(__self__, "delete_mode", delete_mode)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if ip_access_group_in is not None:
            pulumi.set(__self__, "ip_access_group_in", ip_access_group_in)
        if ip_access_group_in_enable is not None:
            pulumi.set(__self__, "ip_access_group_in_enable", ip_access_group_in_enable)
        if ip_access_group_out is not None:
            pulumi.set(__self__, "ip_access_group_out", ip_access_group_out)
        if ip_access_group_out_enable is not None:
            pulumi.set(__self__, "ip_access_group_out_enable", ip_access_group_out_enable)
        if ip_proxy_arp is not None:
            pulumi.set(__self__, "ip_proxy_arp", ip_proxy_arp)
        if ip_redirects is not None:
            pulumi.set(__self__, "ip_redirects", ip_redirects)
        if ip_unreachables is not None:
            pulumi.set(__self__, "ip_unreachables", ip_unreachables)
        if ipv4_address is not None:
            pulumi.set(__self__, "ipv4_address", ipv4_address)
        if ipv4_address_mask is not None:
            pulumi.set(__self__, "ipv4_address_mask", ipv4_address_mask)
        if ipv6_address_autoconfig_default is not None:
            pulumi.set(__self__, "ipv6_address_autoconfig_default", ipv6_address_autoconfig_default)
        if ipv6_address_dhcp is not None:
            pulumi.set(__self__, "ipv6_address_dhcp", ipv6_address_dhcp)
        if ipv6_addresses is not None:
            pulumi.set(__self__, "ipv6_addresses", ipv6_addresses)
        if ipv6_enable is not None:
            pulumi.set(__self__, "ipv6_enable", ipv6_enable)
        if ipv6_link_local_addresses is not None:
            pulumi.set(__self__, "ipv6_link_local_addresses", ipv6_link_local_addresses)
        if ipv6_mtu is not None:
            pulumi.set(__self__, "ipv6_mtu", ipv6_mtu)
        if ipv6_nd_ra_suppress_all is not None:
            pulumi.set(__self__, "ipv6_nd_ra_suppress_all", ipv6_nd_ra_suppress_all)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if shutdown is not None:
            pulumi.set(__self__, "shutdown", shutdown)
        if vrf_forwarding is not None:
            pulumi.set(__self__, "vrf_forwarding", vrf_forwarding)

    @property
    @pulumi.getter(name="arpTimeout")
    def arp_timeout(self) -> Optional[pulumi.Input[int]]:
        """
        Set ARP cache timeout - Range: `0`-`2147483`
        """
        return pulumi.get(self, "arp_timeout")

    @arp_timeout.setter
    def arp_timeout(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "arp_timeout", value)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @delete_mode.setter
    def delete_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_mode", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Interface specific description
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="ipAccessGroupIn")
    def ip_access_group_in(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ip_access_group_in")

    @ip_access_group_in.setter
    def ip_access_group_in(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_access_group_in", value)

    @property
    @pulumi.getter(name="ipAccessGroupInEnable")
    def ip_access_group_in_enable(self) -> Optional[pulumi.Input[bool]]:
        """
        inbound packets
        """
        return pulumi.get(self, "ip_access_group_in_enable")

    @ip_access_group_in_enable.setter
    def ip_access_group_in_enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_access_group_in_enable", value)

    @property
    @pulumi.getter(name="ipAccessGroupOut")
    def ip_access_group_out(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ip_access_group_out")

    @ip_access_group_out.setter
    def ip_access_group_out(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_access_group_out", value)

    @property
    @pulumi.getter(name="ipAccessGroupOutEnable")
    def ip_access_group_out_enable(self) -> Optional[pulumi.Input[bool]]:
        """
        outbound packets
        """
        return pulumi.get(self, "ip_access_group_out_enable")

    @ip_access_group_out_enable.setter
    def ip_access_group_out_enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_access_group_out_enable", value)

    @property
    @pulumi.getter(name="ipProxyArp")
    def ip_proxy_arp(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable proxy ARP
        """
        return pulumi.get(self, "ip_proxy_arp")

    @ip_proxy_arp.setter
    def ip_proxy_arp(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_proxy_arp", value)

    @property
    @pulumi.getter(name="ipRedirects")
    def ip_redirects(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable sending ICMP Redirect messages
        """
        return pulumi.get(self, "ip_redirects")

    @ip_redirects.setter
    def ip_redirects(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_redirects", value)

    @property
    @pulumi.getter(name="ipUnreachables")
    def ip_unreachables(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable sending ICMP Unreachable messages
        """
        return pulumi.get(self, "ip_unreachables")

    @ip_unreachables.setter
    def ip_unreachables(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ip_unreachables", value)

    @property
    @pulumi.getter(name="ipv4Address")
    def ipv4_address(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ipv4_address")

    @ipv4_address.setter
    def ipv4_address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipv4_address", value)

    @property
    @pulumi.getter(name="ipv4AddressMask")
    def ipv4_address_mask(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ipv4_address_mask")

    @ipv4_address_mask.setter
    def ipv4_address_mask(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipv4_address_mask", value)

    @property
    @pulumi.getter(name="ipv6AddressAutoconfigDefault")
    def ipv6_address_autoconfig_default(self) -> Optional[pulumi.Input[bool]]:
        """
        Insert default route
        """
        return pulumi.get(self, "ipv6_address_autoconfig_default")

    @ipv6_address_autoconfig_default.setter
    def ipv6_address_autoconfig_default(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_address_autoconfig_default", value)

    @property
    @pulumi.getter(name="ipv6AddressDhcp")
    def ipv6_address_dhcp(self) -> Optional[pulumi.Input[bool]]:
        """
        Obtain IPv6 address from DHCP server
        """
        return pulumi.get(self, "ipv6_address_dhcp")

    @ipv6_address_dhcp.setter
    def ipv6_address_dhcp(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_address_dhcp", value)

    @property
    @pulumi.getter(name="ipv6Addresses")
    def ipv6_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6AddressArgs']]]]:
        return pulumi.get(self, "ipv6_addresses")

    @ipv6_addresses.setter
    def ipv6_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6AddressArgs']]]]):
        pulumi.set(self, "ipv6_addresses", value)

    @property
    @pulumi.getter(name="ipv6Enable")
    def ipv6_enable(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable IPv6 on interface
        """
        return pulumi.get(self, "ipv6_enable")

    @ipv6_enable.setter
    def ipv6_enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_enable", value)

    @property
    @pulumi.getter(name="ipv6LinkLocalAddresses")
    def ipv6_link_local_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]:
        return pulumi.get(self, "ipv6_link_local_addresses")

    @ipv6_link_local_addresses.setter
    def ipv6_link_local_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]):
        pulumi.set(self, "ipv6_link_local_addresses", value)

    @property
    @pulumi.getter(name="ipv6Mtu")
    def ipv6_mtu(self) -> Optional[pulumi.Input[int]]:
        """
        Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        """
        return pulumi.get(self, "ipv6_mtu")

    @ipv6_mtu.setter
    def ipv6_mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ipv6_mtu", value)

    @property
    @pulumi.getter(name="ipv6NdRaSuppressAll")
    def ipv6_nd_ra_suppress_all(self) -> Optional[pulumi.Input[bool]]:
        """
        Suppress all IPv6 RA
        """
        return pulumi.get(self, "ipv6_nd_ra_suppress_all")

    @ipv6_nd_ra_suppress_all.setter
    def ipv6_nd_ra_suppress_all(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ipv6_nd_ra_suppress_all", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[int]]:
        """
        - Range: `0`-`2147483647`
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def shutdown(self) -> Optional[pulumi.Input[bool]]:
        """
        Shutdown the selected interface
        """
        return pulumi.get(self, "shutdown")

    @shutdown.setter
    def shutdown(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "shutdown", value)

    @property
    @pulumi.getter(name="vrfForwarding")
    def vrf_forwarding(self) -> Optional[pulumi.Input[str]]:
        """
        Configure forwarding table
        """
        return pulumi.get(self, "vrf_forwarding")

    @vrf_forwarding.setter
    def vrf_forwarding(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vrf_forwarding", value)


class InterfaceLoopback(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 arp_timeout: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in_enable: Optional[pulumi.Input[bool]] = None,
                 ip_access_group_out: Optional[pulumi.Input[str]] = None,
                 ip_access_group_out_enable: Optional[pulumi.Input[bool]] = None,
                 ip_proxy_arp: Optional[pulumi.Input[bool]] = None,
                 ip_redirects: Optional[pulumi.Input[bool]] = None,
                 ip_unreachables: Optional[pulumi.Input[bool]] = None,
                 ipv4_address: Optional[pulumi.Input[str]] = None,
                 ipv4_address_mask: Optional[pulumi.Input[str]] = None,
                 ipv6_address_autoconfig_default: Optional[pulumi.Input[bool]] = None,
                 ipv6_address_dhcp: Optional[pulumi.Input[bool]] = None,
                 ipv6_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceLoopbackIpv6AddressArgs']]]]] = None,
                 ipv6_enable: Optional[pulumi.Input[bool]] = None,
                 ipv6_link_local_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]] = None,
                 ipv6_mtu: Optional[pulumi.Input[int]] = None,
                 ipv6_nd_ra_suppress_all: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[int]] = None,
                 shutdown: Optional[pulumi.Input[bool]] = None,
                 vrf_forwarding: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage the Interface Loopback configuration.

        ## Import

        ```sh
         $ pulumi import iosxe:index/interfaceLoopback:InterfaceLoopback example "Cisco-IOS-XE-native:native/interface/Loopback=100"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] arp_timeout: Set ARP cache timeout - Range: `0`-`2147483`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] description: Interface specific description
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[bool] ip_access_group_in_enable: inbound packets
        :param pulumi.Input[bool] ip_access_group_out_enable: outbound packets
        :param pulumi.Input[bool] ip_proxy_arp: Enable proxy ARP
        :param pulumi.Input[bool] ip_redirects: Enable sending ICMP Redirect messages
        :param pulumi.Input[bool] ip_unreachables: Enable sending ICMP Unreachable messages
        :param pulumi.Input[bool] ipv6_address_autoconfig_default: Insert default route
        :param pulumi.Input[bool] ipv6_address_dhcp: Obtain IPv6 address from DHCP server
        :param pulumi.Input[bool] ipv6_enable: Enable IPv6 on interface
        :param pulumi.Input[int] ipv6_mtu: Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        :param pulumi.Input[bool] ipv6_nd_ra_suppress_all: Suppress all IPv6 RA
        :param pulumi.Input[int] name: - Range: `0`-`2147483647`
        :param pulumi.Input[bool] shutdown: Shutdown the selected interface
        :param pulumi.Input[str] vrf_forwarding: Configure forwarding table
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[InterfaceLoopbackArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the Interface Loopback configuration.

        ## Import

        ```sh
         $ pulumi import iosxe:index/interfaceLoopback:InterfaceLoopback example "Cisco-IOS-XE-native:native/interface/Loopback=100"
        ```

        :param str resource_name: The name of the resource.
        :param InterfaceLoopbackArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InterfaceLoopbackArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 arp_timeout: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in: Optional[pulumi.Input[str]] = None,
                 ip_access_group_in_enable: Optional[pulumi.Input[bool]] = None,
                 ip_access_group_out: Optional[pulumi.Input[str]] = None,
                 ip_access_group_out_enable: Optional[pulumi.Input[bool]] = None,
                 ip_proxy_arp: Optional[pulumi.Input[bool]] = None,
                 ip_redirects: Optional[pulumi.Input[bool]] = None,
                 ip_unreachables: Optional[pulumi.Input[bool]] = None,
                 ipv4_address: Optional[pulumi.Input[str]] = None,
                 ipv4_address_mask: Optional[pulumi.Input[str]] = None,
                 ipv6_address_autoconfig_default: Optional[pulumi.Input[bool]] = None,
                 ipv6_address_dhcp: Optional[pulumi.Input[bool]] = None,
                 ipv6_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceLoopbackIpv6AddressArgs']]]]] = None,
                 ipv6_enable: Optional[pulumi.Input[bool]] = None,
                 ipv6_link_local_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]] = None,
                 ipv6_mtu: Optional[pulumi.Input[int]] = None,
                 ipv6_nd_ra_suppress_all: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[int]] = None,
                 shutdown: Optional[pulumi.Input[bool]] = None,
                 vrf_forwarding: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InterfaceLoopbackArgs.__new__(InterfaceLoopbackArgs)

            __props__.__dict__["arp_timeout"] = arp_timeout
            __props__.__dict__["delete_mode"] = delete_mode
            __props__.__dict__["description"] = description
            __props__.__dict__["device"] = device
            __props__.__dict__["ip_access_group_in"] = ip_access_group_in
            __props__.__dict__["ip_access_group_in_enable"] = ip_access_group_in_enable
            __props__.__dict__["ip_access_group_out"] = ip_access_group_out
            __props__.__dict__["ip_access_group_out_enable"] = ip_access_group_out_enable
            __props__.__dict__["ip_proxy_arp"] = ip_proxy_arp
            __props__.__dict__["ip_redirects"] = ip_redirects
            __props__.__dict__["ip_unreachables"] = ip_unreachables
            __props__.__dict__["ipv4_address"] = ipv4_address
            __props__.__dict__["ipv4_address_mask"] = ipv4_address_mask
            __props__.__dict__["ipv6_address_autoconfig_default"] = ipv6_address_autoconfig_default
            __props__.__dict__["ipv6_address_dhcp"] = ipv6_address_dhcp
            __props__.__dict__["ipv6_addresses"] = ipv6_addresses
            __props__.__dict__["ipv6_enable"] = ipv6_enable
            __props__.__dict__["ipv6_link_local_addresses"] = ipv6_link_local_addresses
            __props__.__dict__["ipv6_mtu"] = ipv6_mtu
            __props__.__dict__["ipv6_nd_ra_suppress_all"] = ipv6_nd_ra_suppress_all
            __props__.__dict__["name"] = name
            __props__.__dict__["shutdown"] = shutdown
            __props__.__dict__["vrf_forwarding"] = vrf_forwarding
        super(InterfaceLoopback, __self__).__init__(
            'iosxe:index/interfaceLoopback:InterfaceLoopback',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            arp_timeout: Optional[pulumi.Input[int]] = None,
            delete_mode: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            ip_access_group_in: Optional[pulumi.Input[str]] = None,
            ip_access_group_in_enable: Optional[pulumi.Input[bool]] = None,
            ip_access_group_out: Optional[pulumi.Input[str]] = None,
            ip_access_group_out_enable: Optional[pulumi.Input[bool]] = None,
            ip_proxy_arp: Optional[pulumi.Input[bool]] = None,
            ip_redirects: Optional[pulumi.Input[bool]] = None,
            ip_unreachables: Optional[pulumi.Input[bool]] = None,
            ipv4_address: Optional[pulumi.Input[str]] = None,
            ipv4_address_mask: Optional[pulumi.Input[str]] = None,
            ipv6_address_autoconfig_default: Optional[pulumi.Input[bool]] = None,
            ipv6_address_dhcp: Optional[pulumi.Input[bool]] = None,
            ipv6_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceLoopbackIpv6AddressArgs']]]]] = None,
            ipv6_enable: Optional[pulumi.Input[bool]] = None,
            ipv6_link_local_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceLoopbackIpv6LinkLocalAddressArgs']]]]] = None,
            ipv6_mtu: Optional[pulumi.Input[int]] = None,
            ipv6_nd_ra_suppress_all: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[int]] = None,
            shutdown: Optional[pulumi.Input[bool]] = None,
            vrf_forwarding: Optional[pulumi.Input[str]] = None) -> 'InterfaceLoopback':
        """
        Get an existing InterfaceLoopback resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] arp_timeout: Set ARP cache timeout - Range: `0`-`2147483`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] description: Interface specific description
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[bool] ip_access_group_in_enable: inbound packets
        :param pulumi.Input[bool] ip_access_group_out_enable: outbound packets
        :param pulumi.Input[bool] ip_proxy_arp: Enable proxy ARP
        :param pulumi.Input[bool] ip_redirects: Enable sending ICMP Redirect messages
        :param pulumi.Input[bool] ip_unreachables: Enable sending ICMP Unreachable messages
        :param pulumi.Input[bool] ipv6_address_autoconfig_default: Insert default route
        :param pulumi.Input[bool] ipv6_address_dhcp: Obtain IPv6 address from DHCP server
        :param pulumi.Input[bool] ipv6_enable: Enable IPv6 on interface
        :param pulumi.Input[int] ipv6_mtu: Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        :param pulumi.Input[bool] ipv6_nd_ra_suppress_all: Suppress all IPv6 RA
        :param pulumi.Input[int] name: - Range: `0`-`2147483647`
        :param pulumi.Input[bool] shutdown: Shutdown the selected interface
        :param pulumi.Input[str] vrf_forwarding: Configure forwarding table
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InterfaceLoopbackState.__new__(_InterfaceLoopbackState)

        __props__.__dict__["arp_timeout"] = arp_timeout
        __props__.__dict__["delete_mode"] = delete_mode
        __props__.__dict__["description"] = description
        __props__.__dict__["device"] = device
        __props__.__dict__["ip_access_group_in"] = ip_access_group_in
        __props__.__dict__["ip_access_group_in_enable"] = ip_access_group_in_enable
        __props__.__dict__["ip_access_group_out"] = ip_access_group_out
        __props__.__dict__["ip_access_group_out_enable"] = ip_access_group_out_enable
        __props__.__dict__["ip_proxy_arp"] = ip_proxy_arp
        __props__.__dict__["ip_redirects"] = ip_redirects
        __props__.__dict__["ip_unreachables"] = ip_unreachables
        __props__.__dict__["ipv4_address"] = ipv4_address
        __props__.__dict__["ipv4_address_mask"] = ipv4_address_mask
        __props__.__dict__["ipv6_address_autoconfig_default"] = ipv6_address_autoconfig_default
        __props__.__dict__["ipv6_address_dhcp"] = ipv6_address_dhcp
        __props__.__dict__["ipv6_addresses"] = ipv6_addresses
        __props__.__dict__["ipv6_enable"] = ipv6_enable
        __props__.__dict__["ipv6_link_local_addresses"] = ipv6_link_local_addresses
        __props__.__dict__["ipv6_mtu"] = ipv6_mtu
        __props__.__dict__["ipv6_nd_ra_suppress_all"] = ipv6_nd_ra_suppress_all
        __props__.__dict__["name"] = name
        __props__.__dict__["shutdown"] = shutdown
        __props__.__dict__["vrf_forwarding"] = vrf_forwarding
        return InterfaceLoopback(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="arpTimeout")
    def arp_timeout(self) -> pulumi.Output[Optional[int]]:
        """
        Set ARP cache timeout - Range: `0`-`2147483`
        """
        return pulumi.get(self, "arp_timeout")

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> pulumi.Output[Optional[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Interface specific description
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="ipAccessGroupIn")
    def ip_access_group_in(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "ip_access_group_in")

    @property
    @pulumi.getter(name="ipAccessGroupInEnable")
    def ip_access_group_in_enable(self) -> pulumi.Output[Optional[bool]]:
        """
        inbound packets
        """
        return pulumi.get(self, "ip_access_group_in_enable")

    @property
    @pulumi.getter(name="ipAccessGroupOut")
    def ip_access_group_out(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "ip_access_group_out")

    @property
    @pulumi.getter(name="ipAccessGroupOutEnable")
    def ip_access_group_out_enable(self) -> pulumi.Output[Optional[bool]]:
        """
        outbound packets
        """
        return pulumi.get(self, "ip_access_group_out_enable")

    @property
    @pulumi.getter(name="ipProxyArp")
    def ip_proxy_arp(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable proxy ARP
        """
        return pulumi.get(self, "ip_proxy_arp")

    @property
    @pulumi.getter(name="ipRedirects")
    def ip_redirects(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable sending ICMP Redirect messages
        """
        return pulumi.get(self, "ip_redirects")

    @property
    @pulumi.getter(name="ipUnreachables")
    def ip_unreachables(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable sending ICMP Unreachable messages
        """
        return pulumi.get(self, "ip_unreachables")

    @property
    @pulumi.getter(name="ipv4Address")
    def ipv4_address(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "ipv4_address")

    @property
    @pulumi.getter(name="ipv4AddressMask")
    def ipv4_address_mask(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "ipv4_address_mask")

    @property
    @pulumi.getter(name="ipv6AddressAutoconfigDefault")
    def ipv6_address_autoconfig_default(self) -> pulumi.Output[Optional[bool]]:
        """
        Insert default route
        """
        return pulumi.get(self, "ipv6_address_autoconfig_default")

    @property
    @pulumi.getter(name="ipv6AddressDhcp")
    def ipv6_address_dhcp(self) -> pulumi.Output[Optional[bool]]:
        """
        Obtain IPv6 address from DHCP server
        """
        return pulumi.get(self, "ipv6_address_dhcp")

    @property
    @pulumi.getter(name="ipv6Addresses")
    def ipv6_addresses(self) -> pulumi.Output[Optional[Sequence['outputs.InterfaceLoopbackIpv6Address']]]:
        return pulumi.get(self, "ipv6_addresses")

    @property
    @pulumi.getter(name="ipv6Enable")
    def ipv6_enable(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable IPv6 on interface
        """
        return pulumi.get(self, "ipv6_enable")

    @property
    @pulumi.getter(name="ipv6LinkLocalAddresses")
    def ipv6_link_local_addresses(self) -> pulumi.Output[Optional[Sequence['outputs.InterfaceLoopbackIpv6LinkLocalAddress']]]:
        return pulumi.get(self, "ipv6_link_local_addresses")

    @property
    @pulumi.getter(name="ipv6Mtu")
    def ipv6_mtu(self) -> pulumi.Output[Optional[int]]:
        """
        Set IPv6 Maximum Transmission Unit - Range: `1280`-`9976`
        """
        return pulumi.get(self, "ipv6_mtu")

    @property
    @pulumi.getter(name="ipv6NdRaSuppressAll")
    def ipv6_nd_ra_suppress_all(self) -> pulumi.Output[Optional[bool]]:
        """
        Suppress all IPv6 RA
        """
        return pulumi.get(self, "ipv6_nd_ra_suppress_all")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[int]:
        """
        - Range: `0`-`2147483647`
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def shutdown(self) -> pulumi.Output[Optional[bool]]:
        """
        Shutdown the selected interface
        """
        return pulumi.get(self, "shutdown")

    @property
    @pulumi.getter(name="vrfForwarding")
    def vrf_forwarding(self) -> pulumi.Output[Optional[str]]:
        """
        Configure forwarding table
        """
        return pulumi.get(self, "vrf_forwarding")

