# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InterfaceOspfArgs', 'InterfaceOspf']

@pulumi.input_type
class InterfaceOspfArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 cost: Optional[pulumi.Input[int]] = None,
                 dead_interval: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 hello_interval: Optional[pulumi.Input[int]] = None,
                 message_digest_keys: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]]] = None,
                 mtu_ignore: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_type_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_non_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_multipoint: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_point: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 process_ids: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfProcessIdArgs']]]] = None,
                 ttl_security_hops: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a InterfaceOspf resource.
        :param pulumi.Input[str] type: Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
               `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
               `Port-channel`
        :param pulumi.Input[int] cost: Route cost of this interface - Range: `1`-`65535`
        :param pulumi.Input[int] dead_interval: Interval after which a neighbor is declared dead - Range: `1`-`65535`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] hello_interval: Time between HELLO packets - Range: `1`-`65535`
        :param pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]] message_digest_keys: Message digest authentication password (key)
        :param pulumi.Input[bool] mtu_ignore: Ignores the MTU in DBD packets
        :param pulumi.Input[bool] network_type_broadcast: Specify OSPF broadcast multi-access network
        :param pulumi.Input[bool] network_type_non_broadcast: Specify OSPF NBMA network
        :param pulumi.Input[bool] network_type_point_to_multipoint: Specify OSPF point-to-multipoint network
        :param pulumi.Input[bool] network_type_point_to_point: Specify OSPF point-to-point network
        :param pulumi.Input[int] priority: Router priority - Range: `0`-`255`
        :param pulumi.Input[int] ttl_security_hops: IP hops - Range: `1`-`254`
        """
        pulumi.set(__self__, "type", type)
        if cost is not None:
            pulumi.set(__self__, "cost", cost)
        if dead_interval is not None:
            pulumi.set(__self__, "dead_interval", dead_interval)
        if delete_mode is not None:
            pulumi.set(__self__, "delete_mode", delete_mode)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if hello_interval is not None:
            pulumi.set(__self__, "hello_interval", hello_interval)
        if message_digest_keys is not None:
            pulumi.set(__self__, "message_digest_keys", message_digest_keys)
        if mtu_ignore is not None:
            pulumi.set(__self__, "mtu_ignore", mtu_ignore)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_type_broadcast is not None:
            pulumi.set(__self__, "network_type_broadcast", network_type_broadcast)
        if network_type_non_broadcast is not None:
            pulumi.set(__self__, "network_type_non_broadcast", network_type_non_broadcast)
        if network_type_point_to_multipoint is not None:
            pulumi.set(__self__, "network_type_point_to_multipoint", network_type_point_to_multipoint)
        if network_type_point_to_point is not None:
            pulumi.set(__self__, "network_type_point_to_point", network_type_point_to_point)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if process_ids is not None:
            pulumi.set(__self__, "process_ids", process_ids)
        if ttl_security_hops is not None:
            pulumi.set(__self__, "ttl_security_hops", ttl_security_hops)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
        `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
        `Port-channel`
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def cost(self) -> Optional[pulumi.Input[int]]:
        """
        Route cost of this interface - Range: `1`-`65535`
        """
        return pulumi.get(self, "cost")

    @cost.setter
    def cost(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cost", value)

    @property
    @pulumi.getter(name="deadInterval")
    def dead_interval(self) -> Optional[pulumi.Input[int]]:
        """
        Interval after which a neighbor is declared dead - Range: `1`-`65535`
        """
        return pulumi.get(self, "dead_interval")

    @dead_interval.setter
    def dead_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "dead_interval", value)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @delete_mode.setter
    def delete_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_mode", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="helloInterval")
    def hello_interval(self) -> Optional[pulumi.Input[int]]:
        """
        Time between HELLO packets - Range: `1`-`65535`
        """
        return pulumi.get(self, "hello_interval")

    @hello_interval.setter
    def hello_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "hello_interval", value)

    @property
    @pulumi.getter(name="messageDigestKeys")
    def message_digest_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]]]:
        """
        Message digest authentication password (key)
        """
        return pulumi.get(self, "message_digest_keys")

    @message_digest_keys.setter
    def message_digest_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]]]):
        pulumi.set(self, "message_digest_keys", value)

    @property
    @pulumi.getter(name="mtuIgnore")
    def mtu_ignore(self) -> Optional[pulumi.Input[bool]]:
        """
        Ignores the MTU in DBD packets
        """
        return pulumi.get(self, "mtu_ignore")

    @mtu_ignore.setter
    def mtu_ignore(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "mtu_ignore", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkTypeBroadcast")
    def network_type_broadcast(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF broadcast multi-access network
        """
        return pulumi.get(self, "network_type_broadcast")

    @network_type_broadcast.setter
    def network_type_broadcast(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_broadcast", value)

    @property
    @pulumi.getter(name="networkTypeNonBroadcast")
    def network_type_non_broadcast(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF NBMA network
        """
        return pulumi.get(self, "network_type_non_broadcast")

    @network_type_non_broadcast.setter
    def network_type_non_broadcast(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_non_broadcast", value)

    @property
    @pulumi.getter(name="networkTypePointToMultipoint")
    def network_type_point_to_multipoint(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF point-to-multipoint network
        """
        return pulumi.get(self, "network_type_point_to_multipoint")

    @network_type_point_to_multipoint.setter
    def network_type_point_to_multipoint(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_point_to_multipoint", value)

    @property
    @pulumi.getter(name="networkTypePointToPoint")
    def network_type_point_to_point(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF point-to-point network
        """
        return pulumi.get(self, "network_type_point_to_point")

    @network_type_point_to_point.setter
    def network_type_point_to_point(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_point_to_point", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        Router priority - Range: `0`-`255`
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter(name="processIds")
    def process_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfProcessIdArgs']]]]:
        return pulumi.get(self, "process_ids")

    @process_ids.setter
    def process_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfProcessIdArgs']]]]):
        pulumi.set(self, "process_ids", value)

    @property
    @pulumi.getter(name="ttlSecurityHops")
    def ttl_security_hops(self) -> Optional[pulumi.Input[int]]:
        """
        IP hops - Range: `1`-`254`
        """
        return pulumi.get(self, "ttl_security_hops")

    @ttl_security_hops.setter
    def ttl_security_hops(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ttl_security_hops", value)


@pulumi.input_type
class _InterfaceOspfState:
    def __init__(__self__, *,
                 cost: Optional[pulumi.Input[int]] = None,
                 dead_interval: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 hello_interval: Optional[pulumi.Input[int]] = None,
                 message_digest_keys: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]]] = None,
                 mtu_ignore: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_type_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_non_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_multipoint: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_point: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 process_ids: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfProcessIdArgs']]]] = None,
                 ttl_security_hops: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering InterfaceOspf resources.
        :param pulumi.Input[int] cost: Route cost of this interface - Range: `1`-`65535`
        :param pulumi.Input[int] dead_interval: Interval after which a neighbor is declared dead - Range: `1`-`65535`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] hello_interval: Time between HELLO packets - Range: `1`-`65535`
        :param pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]] message_digest_keys: Message digest authentication password (key)
        :param pulumi.Input[bool] mtu_ignore: Ignores the MTU in DBD packets
        :param pulumi.Input[bool] network_type_broadcast: Specify OSPF broadcast multi-access network
        :param pulumi.Input[bool] network_type_non_broadcast: Specify OSPF NBMA network
        :param pulumi.Input[bool] network_type_point_to_multipoint: Specify OSPF point-to-multipoint network
        :param pulumi.Input[bool] network_type_point_to_point: Specify OSPF point-to-point network
        :param pulumi.Input[int] priority: Router priority - Range: `0`-`255`
        :param pulumi.Input[int] ttl_security_hops: IP hops - Range: `1`-`254`
        :param pulumi.Input[str] type: Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
               `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
               `Port-channel`
        """
        if cost is not None:
            pulumi.set(__self__, "cost", cost)
        if dead_interval is not None:
            pulumi.set(__self__, "dead_interval", dead_interval)
        if delete_mode is not None:
            pulumi.set(__self__, "delete_mode", delete_mode)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if hello_interval is not None:
            pulumi.set(__self__, "hello_interval", hello_interval)
        if message_digest_keys is not None:
            pulumi.set(__self__, "message_digest_keys", message_digest_keys)
        if mtu_ignore is not None:
            pulumi.set(__self__, "mtu_ignore", mtu_ignore)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_type_broadcast is not None:
            pulumi.set(__self__, "network_type_broadcast", network_type_broadcast)
        if network_type_non_broadcast is not None:
            pulumi.set(__self__, "network_type_non_broadcast", network_type_non_broadcast)
        if network_type_point_to_multipoint is not None:
            pulumi.set(__self__, "network_type_point_to_multipoint", network_type_point_to_multipoint)
        if network_type_point_to_point is not None:
            pulumi.set(__self__, "network_type_point_to_point", network_type_point_to_point)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if process_ids is not None:
            pulumi.set(__self__, "process_ids", process_ids)
        if ttl_security_hops is not None:
            pulumi.set(__self__, "ttl_security_hops", ttl_security_hops)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def cost(self) -> Optional[pulumi.Input[int]]:
        """
        Route cost of this interface - Range: `1`-`65535`
        """
        return pulumi.get(self, "cost")

    @cost.setter
    def cost(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cost", value)

    @property
    @pulumi.getter(name="deadInterval")
    def dead_interval(self) -> Optional[pulumi.Input[int]]:
        """
        Interval after which a neighbor is declared dead - Range: `1`-`65535`
        """
        return pulumi.get(self, "dead_interval")

    @dead_interval.setter
    def dead_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "dead_interval", value)

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @delete_mode.setter
    def delete_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_mode", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="helloInterval")
    def hello_interval(self) -> Optional[pulumi.Input[int]]:
        """
        Time between HELLO packets - Range: `1`-`65535`
        """
        return pulumi.get(self, "hello_interval")

    @hello_interval.setter
    def hello_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "hello_interval", value)

    @property
    @pulumi.getter(name="messageDigestKeys")
    def message_digest_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]]]:
        """
        Message digest authentication password (key)
        """
        return pulumi.get(self, "message_digest_keys")

    @message_digest_keys.setter
    def message_digest_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfMessageDigestKeyArgs']]]]):
        pulumi.set(self, "message_digest_keys", value)

    @property
    @pulumi.getter(name="mtuIgnore")
    def mtu_ignore(self) -> Optional[pulumi.Input[bool]]:
        """
        Ignores the MTU in DBD packets
        """
        return pulumi.get(self, "mtu_ignore")

    @mtu_ignore.setter
    def mtu_ignore(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "mtu_ignore", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkTypeBroadcast")
    def network_type_broadcast(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF broadcast multi-access network
        """
        return pulumi.get(self, "network_type_broadcast")

    @network_type_broadcast.setter
    def network_type_broadcast(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_broadcast", value)

    @property
    @pulumi.getter(name="networkTypeNonBroadcast")
    def network_type_non_broadcast(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF NBMA network
        """
        return pulumi.get(self, "network_type_non_broadcast")

    @network_type_non_broadcast.setter
    def network_type_non_broadcast(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_non_broadcast", value)

    @property
    @pulumi.getter(name="networkTypePointToMultipoint")
    def network_type_point_to_multipoint(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF point-to-multipoint network
        """
        return pulumi.get(self, "network_type_point_to_multipoint")

    @network_type_point_to_multipoint.setter
    def network_type_point_to_multipoint(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_point_to_multipoint", value)

    @property
    @pulumi.getter(name="networkTypePointToPoint")
    def network_type_point_to_point(self) -> Optional[pulumi.Input[bool]]:
        """
        Specify OSPF point-to-point network
        """
        return pulumi.get(self, "network_type_point_to_point")

    @network_type_point_to_point.setter
    def network_type_point_to_point(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_type_point_to_point", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        Router priority - Range: `0`-`255`
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter(name="processIds")
    def process_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfProcessIdArgs']]]]:
        return pulumi.get(self, "process_ids")

    @process_ids.setter
    def process_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InterfaceOspfProcessIdArgs']]]]):
        pulumi.set(self, "process_ids", value)

    @property
    @pulumi.getter(name="ttlSecurityHops")
    def ttl_security_hops(self) -> Optional[pulumi.Input[int]]:
        """
        IP hops - Range: `1`-`254`
        """
        return pulumi.get(self, "ttl_security_hops")

    @ttl_security_hops.setter
    def ttl_security_hops(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ttl_security_hops", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
        `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
        `Port-channel`
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class InterfaceOspf(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cost: Optional[pulumi.Input[int]] = None,
                 dead_interval: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 hello_interval: Optional[pulumi.Input[int]] = None,
                 message_digest_keys: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfMessageDigestKeyArgs']]]]] = None,
                 mtu_ignore: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_type_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_non_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_multipoint: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_point: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 process_ids: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfProcessIdArgs']]]]] = None,
                 ttl_security_hops: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage the Interface OSPF configuration.

        ## Import

        ```sh
         $ pulumi import iosxe:index/interfaceOspf:InterfaceOspf example "Cisco-IOS-XE-native:native/interface/Loopback=1/ip/Cisco-IOS-XE-ospf:router-ospf/ospf"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] cost: Route cost of this interface - Range: `1`-`65535`
        :param pulumi.Input[int] dead_interval: Interval after which a neighbor is declared dead - Range: `1`-`65535`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] hello_interval: Time between HELLO packets - Range: `1`-`65535`
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfMessageDigestKeyArgs']]]] message_digest_keys: Message digest authentication password (key)
        :param pulumi.Input[bool] mtu_ignore: Ignores the MTU in DBD packets
        :param pulumi.Input[bool] network_type_broadcast: Specify OSPF broadcast multi-access network
        :param pulumi.Input[bool] network_type_non_broadcast: Specify OSPF NBMA network
        :param pulumi.Input[bool] network_type_point_to_multipoint: Specify OSPF point-to-multipoint network
        :param pulumi.Input[bool] network_type_point_to_point: Specify OSPF point-to-point network
        :param pulumi.Input[int] priority: Router priority - Range: `0`-`255`
        :param pulumi.Input[int] ttl_security_hops: IP hops - Range: `1`-`254`
        :param pulumi.Input[str] type: Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
               `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
               `Port-channel`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InterfaceOspfArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the Interface OSPF configuration.

        ## Import

        ```sh
         $ pulumi import iosxe:index/interfaceOspf:InterfaceOspf example "Cisco-IOS-XE-native:native/interface/Loopback=1/ip/Cisco-IOS-XE-ospf:router-ospf/ospf"
        ```

        :param str resource_name: The name of the resource.
        :param InterfaceOspfArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InterfaceOspfArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cost: Optional[pulumi.Input[int]] = None,
                 dead_interval: Optional[pulumi.Input[int]] = None,
                 delete_mode: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 hello_interval: Optional[pulumi.Input[int]] = None,
                 message_digest_keys: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfMessageDigestKeyArgs']]]]] = None,
                 mtu_ignore: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_type_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_non_broadcast: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_multipoint: Optional[pulumi.Input[bool]] = None,
                 network_type_point_to_point: Optional[pulumi.Input[bool]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 process_ids: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfProcessIdArgs']]]]] = None,
                 ttl_security_hops: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InterfaceOspfArgs.__new__(InterfaceOspfArgs)

            __props__.__dict__["cost"] = cost
            __props__.__dict__["dead_interval"] = dead_interval
            __props__.__dict__["delete_mode"] = delete_mode
            __props__.__dict__["device"] = device
            __props__.__dict__["hello_interval"] = hello_interval
            __props__.__dict__["message_digest_keys"] = message_digest_keys
            __props__.__dict__["mtu_ignore"] = mtu_ignore
            __props__.__dict__["name"] = name
            __props__.__dict__["network_type_broadcast"] = network_type_broadcast
            __props__.__dict__["network_type_non_broadcast"] = network_type_non_broadcast
            __props__.__dict__["network_type_point_to_multipoint"] = network_type_point_to_multipoint
            __props__.__dict__["network_type_point_to_point"] = network_type_point_to_point
            __props__.__dict__["priority"] = priority
            __props__.__dict__["process_ids"] = process_ids
            __props__.__dict__["ttl_security_hops"] = ttl_security_hops
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
        super(InterfaceOspf, __self__).__init__(
            'iosxe:index/interfaceOspf:InterfaceOspf',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cost: Optional[pulumi.Input[int]] = None,
            dead_interval: Optional[pulumi.Input[int]] = None,
            delete_mode: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            hello_interval: Optional[pulumi.Input[int]] = None,
            message_digest_keys: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfMessageDigestKeyArgs']]]]] = None,
            mtu_ignore: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            network_type_broadcast: Optional[pulumi.Input[bool]] = None,
            network_type_non_broadcast: Optional[pulumi.Input[bool]] = None,
            network_type_point_to_multipoint: Optional[pulumi.Input[bool]] = None,
            network_type_point_to_point: Optional[pulumi.Input[bool]] = None,
            priority: Optional[pulumi.Input[int]] = None,
            process_ids: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfProcessIdArgs']]]]] = None,
            ttl_security_hops: Optional[pulumi.Input[int]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'InterfaceOspf':
        """
        Get an existing InterfaceOspf resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] cost: Route cost of this interface - Range: `1`-`65535`
        :param pulumi.Input[int] dead_interval: Interval after which a neighbor is declared dead - Range: `1`-`65535`
        :param pulumi.Input[str] delete_mode: Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
               managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
               Default value is `all`. - Choices: `all`, `attributes`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] hello_interval: Time between HELLO packets - Range: `1`-`65535`
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InterfaceOspfMessageDigestKeyArgs']]]] message_digest_keys: Message digest authentication password (key)
        :param pulumi.Input[bool] mtu_ignore: Ignores the MTU in DBD packets
        :param pulumi.Input[bool] network_type_broadcast: Specify OSPF broadcast multi-access network
        :param pulumi.Input[bool] network_type_non_broadcast: Specify OSPF NBMA network
        :param pulumi.Input[bool] network_type_point_to_multipoint: Specify OSPF point-to-multipoint network
        :param pulumi.Input[bool] network_type_point_to_point: Specify OSPF point-to-point network
        :param pulumi.Input[int] priority: Router priority - Range: `0`-`255`
        :param pulumi.Input[int] ttl_security_hops: IP hops - Range: `1`-`254`
        :param pulumi.Input[str] type: Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
               `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
               `Port-channel`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InterfaceOspfState.__new__(_InterfaceOspfState)

        __props__.__dict__["cost"] = cost
        __props__.__dict__["dead_interval"] = dead_interval
        __props__.__dict__["delete_mode"] = delete_mode
        __props__.__dict__["device"] = device
        __props__.__dict__["hello_interval"] = hello_interval
        __props__.__dict__["message_digest_keys"] = message_digest_keys
        __props__.__dict__["mtu_ignore"] = mtu_ignore
        __props__.__dict__["name"] = name
        __props__.__dict__["network_type_broadcast"] = network_type_broadcast
        __props__.__dict__["network_type_non_broadcast"] = network_type_non_broadcast
        __props__.__dict__["network_type_point_to_multipoint"] = network_type_point_to_multipoint
        __props__.__dict__["network_type_point_to_point"] = network_type_point_to_point
        __props__.__dict__["priority"] = priority
        __props__.__dict__["process_ids"] = process_ids
        __props__.__dict__["ttl_security_hops"] = ttl_security_hops
        __props__.__dict__["type"] = type
        return InterfaceOspf(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def cost(self) -> pulumi.Output[Optional[int]]:
        """
        Route cost of this interface - Range: `1`-`65535`
        """
        return pulumi.get(self, "cost")

    @property
    @pulumi.getter(name="deadInterval")
    def dead_interval(self) -> pulumi.Output[Optional[int]]:
        """
        Interval after which a neighbor is declared dead - Range: `1`-`65535`
        """
        return pulumi.get(self, "dead_interval")

    @property
    @pulumi.getter(name="deleteMode")
    def delete_mode(self) -> pulumi.Output[Optional[str]]:
        """
        Configure behavior when deleting/destroying the resource. Either delete the entire object (YANG container) being
        managed, or only delete the individual resource attributes configured explicitly and leave everything else as-is.
        Default value is `all`. - Choices: `all`, `attributes`
        """
        return pulumi.get(self, "delete_mode")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="helloInterval")
    def hello_interval(self) -> pulumi.Output[Optional[int]]:
        """
        Time between HELLO packets - Range: `1`-`65535`
        """
        return pulumi.get(self, "hello_interval")

    @property
    @pulumi.getter(name="messageDigestKeys")
    def message_digest_keys(self) -> pulumi.Output[Optional[Sequence['outputs.InterfaceOspfMessageDigestKey']]]:
        """
        Message digest authentication password (key)
        """
        return pulumi.get(self, "message_digest_keys")

    @property
    @pulumi.getter(name="mtuIgnore")
    def mtu_ignore(self) -> pulumi.Output[Optional[bool]]:
        """
        Ignores the MTU in DBD packets
        """
        return pulumi.get(self, "mtu_ignore")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkTypeBroadcast")
    def network_type_broadcast(self) -> pulumi.Output[Optional[bool]]:
        """
        Specify OSPF broadcast multi-access network
        """
        return pulumi.get(self, "network_type_broadcast")

    @property
    @pulumi.getter(name="networkTypeNonBroadcast")
    def network_type_non_broadcast(self) -> pulumi.Output[Optional[bool]]:
        """
        Specify OSPF NBMA network
        """
        return pulumi.get(self, "network_type_non_broadcast")

    @property
    @pulumi.getter(name="networkTypePointToMultipoint")
    def network_type_point_to_multipoint(self) -> pulumi.Output[Optional[bool]]:
        """
        Specify OSPF point-to-multipoint network
        """
        return pulumi.get(self, "network_type_point_to_multipoint")

    @property
    @pulumi.getter(name="networkTypePointToPoint")
    def network_type_point_to_point(self) -> pulumi.Output[Optional[bool]]:
        """
        Specify OSPF point-to-point network
        """
        return pulumi.get(self, "network_type_point_to_point")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[Optional[int]]:
        """
        Router priority - Range: `0`-`255`
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter(name="processIds")
    def process_ids(self) -> pulumi.Output[Optional[Sequence['outputs.InterfaceOspfProcessId']]]:
        return pulumi.get(self, "process_ids")

    @property
    @pulumi.getter(name="ttlSecurityHops")
    def ttl_security_hops(self) -> pulumi.Output[Optional[int]]:
        """
        IP hops - Range: `1`-`254`
        """
        return pulumi.get(self, "ttl_security_hops")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Interface type - Choices: `GigabitEthernet`, `TwoGigabitEthernet`, `FiveGigabitEthernet`, `TenGigabitEthernet`,
        `TwentyFiveGigE`, `FortyGigabitEthernet`, `HundredGigE`, `TwoHundredGigE`, `FourHundredGigE`, `Loopback`, `Vlan`,
        `Port-channel`
        """
        return pulumi.get(self, "type")

