# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetLoggingIpv6HostTransportResult',
    'AwaitableGetLoggingIpv6HostTransportResult',
    'get_logging_ipv6_host_transport',
    'get_logging_ipv6_host_transport_output',
]

@pulumi.output_type
class GetLoggingIpv6HostTransportResult:
    """
    A collection of values returned by getLoggingIpv6HostTransport.
    """
    def __init__(__self__, device=None, id=None, ipv6_host=None, transport_tcp_ports=None, transport_tls_ports=None, transport_udp_ports=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ipv6_host and not isinstance(ipv6_host, str):
            raise TypeError("Expected argument 'ipv6_host' to be a str")
        pulumi.set(__self__, "ipv6_host", ipv6_host)
        if transport_tcp_ports and not isinstance(transport_tcp_ports, list):
            raise TypeError("Expected argument 'transport_tcp_ports' to be a list")
        pulumi.set(__self__, "transport_tcp_ports", transport_tcp_ports)
        if transport_tls_ports and not isinstance(transport_tls_ports, list):
            raise TypeError("Expected argument 'transport_tls_ports' to be a list")
        pulumi.set(__self__, "transport_tls_ports", transport_tls_ports)
        if transport_udp_ports and not isinstance(transport_udp_ports, list):
            raise TypeError("Expected argument 'transport_udp_ports' to be a list")
        pulumi.set(__self__, "transport_udp_ports", transport_udp_ports)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The path of the retrieved object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipv6Host")
    def ipv6_host(self) -> str:
        return pulumi.get(self, "ipv6_host")

    @property
    @pulumi.getter(name="transportTcpPorts")
    def transport_tcp_ports(self) -> Sequence['outputs.GetLoggingIpv6HostTransportTransportTcpPortResult']:
        """
        Port Number List
        """
        return pulumi.get(self, "transport_tcp_ports")

    @property
    @pulumi.getter(name="transportTlsPorts")
    def transport_tls_ports(self) -> Sequence['outputs.GetLoggingIpv6HostTransportTransportTlsPortResult']:
        """
        Port Number List
        """
        return pulumi.get(self, "transport_tls_ports")

    @property
    @pulumi.getter(name="transportUdpPorts")
    def transport_udp_ports(self) -> Sequence['outputs.GetLoggingIpv6HostTransportTransportUdpPortResult']:
        """
        Port Number List
        """
        return pulumi.get(self, "transport_udp_ports")


class AwaitableGetLoggingIpv6HostTransportResult(GetLoggingIpv6HostTransportResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLoggingIpv6HostTransportResult(
            device=self.device,
            id=self.id,
            ipv6_host=self.ipv6_host,
            transport_tcp_ports=self.transport_tcp_ports,
            transport_tls_ports=self.transport_tls_ports,
            transport_udp_ports=self.transport_udp_ports)


def get_logging_ipv6_host_transport(device: Optional[str] = None,
                                    ipv6_host: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLoggingIpv6HostTransportResult:
    """
    This data source can read the Logging IPv6 Host Transport configuration.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_iosxe as iosxe

    example = iosxe.iosxe.get_logging_ipv6_host_transport(ipv6_host="2001::1")
    ```


    :param str device: A device name from the provider configuration.
    """
    __args__ = dict()
    __args__['device'] = device
    __args__['ipv6Host'] = ipv6_host
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('iosxe:iosxe/getLoggingIpv6HostTransport:getLoggingIpv6HostTransport', __args__, opts=opts, typ=GetLoggingIpv6HostTransportResult).value

    return AwaitableGetLoggingIpv6HostTransportResult(
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        ipv6_host=pulumi.get(__ret__, 'ipv6_host'),
        transport_tcp_ports=pulumi.get(__ret__, 'transport_tcp_ports'),
        transport_tls_ports=pulumi.get(__ret__, 'transport_tls_ports'),
        transport_udp_ports=pulumi.get(__ret__, 'transport_udp_ports'))


@_utilities.lift_output_func(get_logging_ipv6_host_transport)
def get_logging_ipv6_host_transport_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                                           ipv6_host: Optional[pulumi.Input[str]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetLoggingIpv6HostTransportResult]:
    """
    This data source can read the Logging IPv6 Host Transport configuration.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_iosxe as iosxe

    example = iosxe.iosxe.get_logging_ipv6_host_transport(ipv6_host="2001::1")
    ```


    :param str device: A device name from the provider configuration.
    """
    ...
